""" This module import all constants that are defined for the LAPIN module
"""

from lapin.constants.restrictions import (
    VEH_SIZE,
    CAP_START_RES,
    CAP_END_RES,
    CAP_RES_DT_FROM,
    CAP_RES_DT_TO,
    CAP_RES_HOUR_TO,
    CAP_RES_HOUR_FROM,
    CAP_RES_DAYS,
    CAP_RES_TYPE,
    CAP_RESTRICTIONS,
    CAP_IS_RESTRICT,
    CAP_DELIM_SPACE,
    CAP_SPACE,
    CAP_N_DELIM_S,
    CAP_N_UNDELIM_S,
    CAP_N_VEH,
    CAP_CACHE_PATH,
    CAP_MINIMAL_LENGTH,
    CAP_PRIORITY,
    IGNORE_FOR_CAPACITY,
    CAP_DAYS_HOUR_TO_COMPUTE,
    FRENCH_WEEK_DAY_CAT,
    DEFAULT_COLS_CRUNCH,
)
from lapin.constants.road_network import (
    ROAD_NAME,
    HR_ROAD_NAME,
    HR_FROM_ROAD,
    HR_TO_ROAD,
    TRAFFIC_DIR,
    SEG_DB_GIS,
    SEG_DB_ID,
    SEG_DB_ID_SIDE,
    SEG_DB_SIDE,
    SEG_DB_STREET,
    SEG_DB_SIDE_OF_STREET_MAP,
)
from lapin.constants.geom import UNIVERSAL_CRS, DEFAULT_CRS, MONTREAL_CRS, EARTH_RADIUS
from lapin.constants.io import CACHE
from lapin.constants.lpr_data import (
    INDEX,
    UUID,
    PLATE,
    LATITUDE,
    LONGITUDE,
    SIDE_OF_CAR,
    DATETIME,
    ORIGIN_LAT,
    ORIGIN_LNG,
    DESTINATION_LAT,
    DESTINATION_LNG,
    GEOMETRY,
    DFLT_LPR_CONF,
    DFLT_TRJ_CONF,
    DATE_KWARGS,
)
from lapin.constants.timezone import PROJECT_TIMEZONE
from lapin.constants.enhancement import (
    SEGMENT,
    POINT_ON_STREET,
    SIDE_OF_STREET,
    SIDE_OF_STREET_VIZ,
    LAP,
    LAP_TIME,
    LAT_SMOOTH,
    LNG_SMOOTH,
)
from lapin.constants.analyses import (
    HOUR_BOUNDS,
    SECTEUR_NAME,
    REMPL_CAT_NO_PARK,
    TRIPS_COLS,
    TRIPS_WEEK,
    SIDE_OF_STREET_INFO,
    OCCUPATION_INFO,
)

from lapin.constants.mapmatch import VALHALLA_DFLT_FOLDER


__all__ = [
    "HOUR_BOUNDS",
    "SECTEUR_NAME",
    "REMPL_CAT_NO_PARK",
    "TRIPS_COLS",
    "TRIPS_WEEK",
    "CACHE",
    "SIDE_OF_STREET_INFO",
    "OCCUPATION_INFO",
    "SEGMENT",
    "POINT_ON_STREET",
    "SIDE_OF_STREET",
    "SIDE_OF_STREET_VIZ",
    "LAP",
    "LAP_TIME",
    "LAT_SMOOTH",
    "LNG_SMOOTH",
    "UNIVERSAL_CRS",
    "DEFAULT_CRS",
    "MONTREAL_CRS",
    "EARTH_RADIUS",
    "CACHE",
    "INDEX",
    "UUID",
    "PLATE",
    "LATITUDE",
    "LONGITUDE",
    "SIDE_OF_CAR",
    "DATETIME",
    "ORIGIN_LAT",
    "ORIGIN_LNG",
    "DESTINATION_LAT",
    "DESTINATION_LNG",
    "GEOMETRY",
    "VEH_SIZE",
    "CAP_START_RES",
    "CAP_END_RES",
    "CAP_RES_DT_FROM",
    "CAP_RES_DT_TO",
    "CAP_RES_HOUR_TO",
    "CAP_RES_HOUR_FROM",
    "CAP_RES_DAYS",
    "CAP_RES_TYPE",
    "CAP_RESTRICTIONS",
    "CAP_IS_RESTRICT",
    "CAP_DELIM_SPACE",
    "CAP_SPACE",
    "CAP_N_DELIM_S",
    "CAP_N_UNDELIM_S",
    "CAP_N_VEH",
    "CAP_CACHE_PATH",
    "CAP_MINIMAL_LENGTH",
    "CAP_PRIORITY",
    "IGNORE_FOR_CAPACITY",
    "CAP_DAYS_HOUR_TO_COMPUTE",
    "FRENCH_WEEK_DAY_CAT",
    "DEFAULT_COLS_CRUNCH",
    "HR_ROAD_NAME",
    "HR_FROM_ROAD",
    "HR_TO_ROAD",
    "SEG_DB_GIS",
    "SEG_DB_ID",
    "SEG_DB_ID_SIDE",
    "SEG_DB_SIDE",
    "ROAD_NAME",
    "SEG_DB_STREET",
    "SEG_DB_SIDE_OF_STREET_MAP",
    "PROJECT_TIMEZONE",
    "TRAFFIC_DIR",
    "DFLT_TRJ_CONF",
    "DFLT_LPR_CONF",
    "VALHALLA_DFLT_FOLDER",
    "DATE_KWARGS",
]
